using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.UnitMeasure.Cqrs;

public class GetUnitMeasureByIdResponse
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public record GetUnitMeasureByIdQuery(string Id) : IRequest<GetUnitMeasureByIdResponse?>;

public class GetUnitMeasureByIdHandler : IRequestHandler<GetUnitMeasureByIdQuery, GetUnitMeasureByIdResponse?>
{
    private readonly AppDbContext _context;

    public GetUnitMeasureByIdHandler(AppDbContext context) => _context = context;

    public async Task<GetUnitMeasureByIdResponse?> Handle(GetUnitMeasureByIdQuery request, CancellationToken cancellationToken)
    {
        return await _context.UnitMeasure
            .AsNoTracking()
            .Where(x => x.Id == request.Id)
            .Select(x => new GetUnitMeasureByIdResponse
            {
                Id = x.Id,
                Name = x.Name,
                Description = x.Description,
                CreatedAt = x.CreatedAt,
                CreatedBy = x.CreatedBy,
                UpdatedAt = x.UpdatedAt,
                UpdatedBy = x.UpdatedBy,
            })
            .FirstOrDefaultAsync(cancellationToken);
    }
}